#
# Horror clock
#
# Author: CrazyCat <crazycat@c-p-f.org>
# http://www.eggdrop.fr
# irc.zeolia.net #c-p-f
#
# A really stressant clock
#
# Usage:
# !clock <on|off> : turns the clock on/off

namespace eval hclock {
	
	variable author "CrazyCat"
	variable version "1.0"

	variable cchan ""
	
	bind pub o|- !clock hclock::active
	
	# Quick output
	proc putqueue { data } {
		append data "\n"
		putdccraw 0 [string length $data] $data
		return
	}
	
	# Sets the clock on/off
	proc active {nick uhost handle chan args} {
		variable cchan
		set act [lindex $args 0]
		switch -- [string tolower $act] {
			on {
				if { $cchan != "" } {
					puthelp "PRIVMSG $chan :HClock est dj actif"
					return 0
				}
				set cchan [string tolower $chan]
				putlog "$chan : $cchan"
				hclock::on
			}
			off {
				if { $cchan == "" } {
					puthelp "PRIVMSG $chan :HClock n'est pas actif"
					return 0
				}
				if { $cchan != [string tolower $chan] } {
					puthelp "PRIVMSG $chan :HClock n'est pas actif sur ce canal"
					return 0
				}
				set cchan ""
				hclock::off
			}
			default {
				puthelp "PRIVMSG $chan :Erreur: \002!clock <on|off>\002"
			}
		}
	}
	
	# clock start
	proc on {} {
		variable cchan
		if { $cchan == "" } {
			return 0
		}
		set now [expr [clock seconds] % 2]
		set min [clock format [clock seconds] -format "%M%S"]
		switch -- $min {
			0000 {
				putquick "PRIVMSG $cchan :Ding Dang Dong!"
				set delay 10
			}
			1500
				-
			4500 {
				putquick "PRIVMSG $cchan :Ding!"
				set delay 3
				
			}
			3000 {
				putquick "PRIVMSG $cchan :Ding Ding!"
				set delay 5
			}
			default {
				if { $now == 0 } {
					hclock::putqueue "PRIVMSG $cchan :Tic";
				} else {
					hclock::putqueue "PRIVMSG $cchan :Tac";
				}
				set delay 1
			}
		}
		utimer $delay hclock::on
	}
	
	# clock stop
	proc off {} {
		variable cchan
		putserv "PRIVMSG $cchan :HClock coupe sur $cchan"
		set cchan ""
		return
	}
}

putlog "Horror Clock $hclock::version by $hclock::author loaded"